diff --git a/sylk/session.py b/sylk/session.py
index f7f9406..d370c8c 100644
--- a/sylk/session.py
+++ b/sylk/session.py
@@ -888,6 +888,9 @@ class Session(object):
             notification_center.remove_observer(self, sender=self._invitation)
             self.greenlet = None
             self.state = 'terminated'
+            for stream in self.proposed_streams:
+                stream.deactivate()
+                stream.end()
             self.proposed_streams = None
             notification_center.post_notification('SIPSessionDidFail', self, NotificationData(originator='remote', code=487, reason='Session Cancelled', failure_reason='user request', redirect_identities=None))
         except SIPCoreError as e:
@@ -896,12 +899,18 @@ class Session(object):
             notification_center.remove_observer(self, sender=self._invitation)
             self.greenlet = None
             self.state = 'terminated'
+            for stream in self.proposed_streams:
+                stream.deactivate()
+                stream.end()
             self.proposed_streams = None
             notification_center.post_notification('SIPSessionDidFail', self, NotificationData(originator='local', code=code, reason=sip_status_messages[code], failure_reason='timeout', redirect_identities=None))
         else:
             notification_center.remove_observer(self, sender=self._invitation)
             self.greenlet = None
             self.state = 'terminated'
+            for stream in self.proposed_streams:
+                stream.deactivate()
+                stream.end()
             self.proposed_streams = None
             notification_center.post_notification('SIPSessionDidFail', self, NotificationData(originator='local', code=code, reason=sip_status_messages[code], failure_reason='user request', redirect_identities=None))
 
@@ -1851,6 +1860,10 @@ class Session(object):
                 elif notification.data.state == 'disconnected':
                     if self.state == 'incoming':
                         self.state = 'terminated'
+                        for stream in self.proposed_streams:
+                            stream.deactivate()
+                            stream.end()
+                        self.proposed_streams = None
                         if notification.data.originator == 'remote':
                             notification.center.post_notification('SIPSessionDidFail', self, NotificationData(originator='remote', code=487, reason='Session Cancelled', failure_reason=notification.data.disconnect_reason, redirect_identities=None))
                         else:
